<?php
/**
* loadmodule_for_category_description plugin
* allows embedding of modules in the section/category description
* Note: This is modified from the standard loadmodule plugin
* that comes bundled with the original Joomla 1.0.x install
* @version 1.0
* @package None
* @copyright (C) Copyright 2006-2008 by kksou.com
* Author: kksou
* Website: http://www.kksou.com/php-gtk2
* v1.0 April 16, 2008
*/

/**
* This is the original copyright information from mosloadposition.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

###$mainframe->registerEvent( 'onPrepareContent', 'plgContentLoadModule' );
$mainframe->registerEvent( 'onBeforeDisplayTitle', 'plgContentLoadModule_BeforeDisplayTitle' );

/**
* Plugin that loads module positions within content
*/
function plgContentLoadModule_BeforeDisplayTitle( &$title )
{
	$db =& JFactory::getDBO();
	// simple performance check to determine whether bot should process further
	if ( JString::strpos( $title->description, 'loadposition' ) === false ) {
		return true;
	}

	// Get plugin info
	$plugin =& JPluginHelper::getPlugin('content', 'loadmodule');

 	// expression to search for
 	$regex = '/{loadposition\s*.*?}/i';

 	$pluginParams = new JParameter( $plugin->params );

	// check whether plugin has been unpublished
	#if ( !$pluginParams->get( 'enabled', 1 ) ) {
	#	$row->text = preg_replace( $regex, '', $row->text );
	#	return true;
	#}

 	// find all instances of plugin and put in $matches
	preg_match_all( $regex, $title->description, $matches );

	// Number of plugins
 	$count = count( $matches[0] );

 	// plugin only processes if there are any instances of the plugin in the text
 	if ( $count ) {
		// Get plugin parameters
	 	$style	= $pluginParams->def( 'style', -2 );

 		plgContentProcessPositions_BeforeDisplayTitle( $title, $matches, $count, $regex, $style );
	}
}

function plgContentProcessPositions_BeforeDisplayTitle ( &$title, &$matches, $count, $regex, $style )
{
 	for ( $i=0; $i < $count; $i++ )
	{
 		$load = str_replace( 'loadposition', '', $matches[0][$i] );
 		$load = str_replace( '{', '', $load );
 		$load = str_replace( '}', '', $load );
 		$load = trim( $load );

		$modules	= plgContentLoadPosition_BeforeDisplayTitle( $load, $style );
		$title->description	= preg_replace( '{'. $matches[0][$i] .'}', $modules, $title->description );
 	}

  	// removes tags without matching module positions
	$title->description = preg_replace( $regex, '', $title->description );
}

function plgContentLoadPosition_BeforeDisplayTitle( $position, $style=-2 )
{
	$document	= &JFactory::getDocument();
	$renderer	= $document->loadRenderer('module');
	$params		= array('style'=>$style);

	$contents = '';
	foreach (JModuleHelper::getModules($position) as $mod)  {
		$contents .= $renderer->render($mod, $params);
	}
	return $contents;
}